/*********************************************************************
* 	WarpSharpMT for AviUtl (SSSE3 Only)
* 								ver. 1.20
* 
* AviSynthłWarpSharpGPL炵̂ŁAGPLɂȂ܂B
* 
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
* (at your option) any later version.
* 
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA, or visit
* http://www.gnu.org/copyleft/gpl.html .
* 
* 
* ===== WarpSharp for AviUtl ======
* [2003]
* 	10/19:	J(0.01)
* 			ŉ[ɃS~ooOC(0.01a)
* [2004]
* 	01/10:	Cubic4Tableł̖ʂȍČvZ
* 	01/12:	K͈͂̐ݒǉ(0.02)
* 	01/26:	K͈̓p[^̍őlg
* 	12/13:	01/10̏CsŜC
* [2008]
* 	06/28:	ڂȃdl̂͂Amۗʂ̂܂܂~XC
* 			Cubic4TableČvZ͊ɉĂ(041213)ǁAfunc_updateɈړB
* 			bumpdepth256ŃI[o[t[ȂB
* 			ڂŉ[ʂ茩ǑvȂ͂B
* 			K͈̓p[^傫鎞̖040126ɏCĂ݂B
* 			XVYĂ܂B߂ȂB(0.03)
* 
* ===== WarpSharpMT for AviUtl ===========
* [2008]
* 	06/22:	MT (1.00)
* 			ڂ̍ŉ[̌vZ~X(QƈʒuԈႢ)oOC
*			K͈͂TCYȏɂƗoOC
*			Cubic4Table𖈃t[ČvZĂ̂
*	06/24:	SSE2gp (1.10)
*			I[o[t[̂bump256255ɕύX(depth͂)
*			
*	07/08:	0.03x[XɕύX(1.20)
*			SSSE3p
*			SIMD
*			Warpsharp MTł̃oOC
* 
*********************************************************************/

#include <windows.h>
#include <math.h>
#if defined(__INTEL_COMPILER)
#include <ia32intrin.h>
#include <tmmintrin.h>
#else
#include <intrin.h>
#endif
#include "filter.h"

#if defined(DEBUG)
/*---------------------------------------------------------------------------
// for calcurate performance
//-------------------------------------------------------------------------*/
#include "text.h"
#include <stdio.h>
#include <stdlib.h>
static double perfsum[16];
static unsigned long perfcount[16];

unsigned __int64* _perf_start(void)
{
	unsigned __int64* stime;
	stime = (unsigned __int64*)malloc(sizeof(*stime));
	*stime = _rdtsc();
	return stime;
}

void _perf_end(unsigned __int64 *stime, int index)
{
	*stime = _rdtsc() - *stime;
	perfsum[index] += (double)(*stime);
	perfcount[index] ++;
	free(stime);
}

void _perf_result(FILTER_PROC_INFO *fpip, EXFUNC *func)
{
	static PIXEL bg = {255,  0,  0};
	static PIXEL fg = {255,255,255};
	char stmp[512];
	double perf[16];
	for(int i=0;i<16;i++)
	{
		if(perfcount[i]!=0)
			perf[i] = perfsum[i]/(double)perfcount[i];
		else
			perf[i] = 0.0;
	}
	sprintf(stmp, " 0 %f\n 1 %f\n 2 %f\n 3 %f\n 4 %f\n 5 %f\n 6 %f\n 7 %f\n 8 %f\n 9 %f\n10 %f\n11 %f\n12 %f\n13 %f\n14 %f\n15 %f"
		, perf[0], perf[1], perf[2], perf[3], perf[4], perf[5], perf[6], perf[7], perf[8], perf[9], perf[10], perf[11], perf[12]
		, perf[13], perf[14], perf[15]);
	show_text(stmp, fpip->ycp_edit, 256, 256, fpip->max_w, &bg, &fg, func);
}
#endif

//--------------------------------------------------------------------
//	class Cubic4Table	warpsharp.h
//--------------------------------------------------------------------
class Cubic4Table {
	int table[1024];
	int a;

public:
	Cubic4Table(int _a =-6)
	{
		a = _a+1;
		SetTable(_a);
	}

	void SetTable(int _a)
	{
		if(a==_a) return;

		a = _a;
	
		double A = (double)_a / 10;
		for(int i=0; i<256; i++) {
			double d = (double)i / 256.0;
			int y1, y2, y3, y4, ydiff;

			// Coefficients for all four pixels *must* add up to 1.0 for
			// consistent unity gain.
			//
			// Two good values for A are -1.0 (original VirtualDub bicubic filter)
			// and -0.75 (closely matches Photoshop).

			y1 = (int)floor(0.5 + (      + A*d -       2.0*A*d*d +       A*d*d*d) * 16384.0);
			y2 = (int)floor(0.5 + (+ 1.0       -     (A+3.0)*d*d + (A+2.0)*d*d*d) * 16384.0);
			y3 = (int)floor(0.5 + (      - A*d + (2.0*A+3.0)*d*d - (A+2.0)*d*d*d) * 16384.0);
			y4 = (int)floor(0.5 + (            +           A*d*d -       A*d*d*d) * 16384.0);

			// Normalize y's so they add up to 16384.

			ydiff = (16384 - y1 - y2 - y3 - y4)/4;
//			assert(ydiff > -16 && ydiff < 16);

			y1 += ydiff;
			y2 += ydiff;
			y3 += ydiff;
			y4 += ydiff;

//			if (mmx_table) {
//				table[i*4 + 0] = (y2<<16) | (y1 & 0xffff);
//				table[i*4 + 1] = (y4<<16) | (y3 & 0xffff);
//				table[i*4 + 2] = table[i*4 + 3] = 0;
//			} else {
				table[i*4 + 0] = y1;
				table[i*4 + 1] = y2;
				table[i*4 + 2] = y3;
				table[i*4 + 3] = y4;
//			}
		}
	}

	const int *GetTable() const
	{ return table; }

	operator int* (void)
	{ return table; }
};

//--------------------------------------------------------------------
//	class DefaultPicture
//--------------------------------------------------------------------
class DefaultPicture {
	PIXEL_YC* ycp_edit;
	PIXEL_YC* ycp_temp;
	int       h,w;
public:
	DefaultPicture(){  }
	DefaultPicture(const FILTER_PROC_INFO* fpip)
	{
		ycp_edit = fpip->ycp_edit;
		ycp_temp = fpip->ycp_temp;
		h = fpip->h;
		w = fpip->w;
	}

	void Store(FILTER_PROC_INFO* fpip)
	{
		fpip->ycp_edit = ycp_edit;
		fpip->ycp_temp = ycp_temp;
		fpip->h = h;
		fpip->w = w;
	}
	void ExchangeStore(FILTER_PROC_INFO* fpip)
	{
		fpip->ycp_edit = ycp_temp;
		fpip->ycp_temp = ycp_edit;
		fpip->h = h;
		fpip->w = w;
	}
};

typedef struct {
	FILTER				*fp;
	FILTER_PROC_INFO	*fpip;
} FILTER_PARAM;

typedef struct {
	short	*dst;
	short	*buf;
} BLUR_PARAM;

typedef struct {
	short	*bump;
	short	*src_y;
} BUMP_PARAM;

//----------------------------
//	O[oϐ
//----------------------------
const int radius = 2;
const int kernel = radius * 2 + 1;
static Cubic4Table cubic;
static int fixedw;
static const _MM_ALIGN16 short c3[8] = {3, 3, 3, 3, 3, 3, 3, 3};
static const _MM_ALIGN16 short c5[8] = {5, 5, 5, 5, 5, 5, 5, 5};
static const _MM_ALIGN16 short c6[8] = {6, 6, 6, 6, 6, 6, 6, 6};
static const _MM_ALIGN16 short c8[8] = {8, 8, 8, 8, 8, 8, 8, 8};
static const _MM_ALIGN16 short c11[8] = {11, 11, 11, 11, 11, 11, 11, 11};
static const _MM_ALIGN16 short c4095[8] = {4095, 4095, 4095, 4095, 4095, 4095, 4095, 4095};


//----------------------------
//	vg^Cv
//----------------------------
inline int InterpolateCubic(const short* src,int pitch,const int *qh,const int *qv);
inline int AviUtlY(int y){ return ((y-15)*16 * 256 +110) / 220; }
static void  CopyEdge(FILTER *fp,FILTER_PROC_INFO *fpip);

// MT֐
static void PickY(short *dst,const FILTER_PROC_INFO* fpip,int y_start, int y_end);
static void PickY_MT(int thread_id,int thread_num,void *param1,void *param2);
static void Bump(short *dst,const short *src,const FILTER_PROC_INFO* fpip,int bump, int y_start, int y_end);
static void Bump_MT(int thread_id,int thread_num,void *param1,void *param2);
static void BlurRow(short *dst, short* src, const FILTER_PROC_INFO* fpip, int y_start, int y_end);
static void BlurRow_MT(int thread_id,int thread_num,void *param1,void *param2);
static void BlurCol(short *dst, short* buf, const FILTER_PROC_INFO* fpip, int x_start, int x_end);
static void BlurCol_MT(int thread_id,int thread_num,void *param1,void *param2);
static void WarpSharp(short *bum, short *ysrc, const FILTER *fp, const FILTER_PROC_INFO* fpip, int y_start, int y_end);
static void WarpSharp_MT(int thread_id,int thread_num,void *param1,void *param2);
static BOOL NegaPosi(FILTER *fp,FILTER_PROC_INFO *fpip, int y_start, int y_end);
static void NegaPosi_MT(int thread_id,int thread_num,void *param1,void *param2);


//----------------------------
//	FILTER_DLL\
//----------------------------
char filtername[] = "WarpSharpMT";
char filterinfo[] = "WarpSharpMT for AviUtl ver 1.20 by BS";
#define track_N 8
#if track_N
TCHAR *track_name[]   = { "depth", "blur", "bump", "cubic", "", "", "", "E"};	// gbNo[̖O
int   track_default[] = {    128 ,     3 ,   128 ,     -6 ,   0 ,   0 ,   0 ,   0 };	// gbNo[̏l
int   track_s[]       = {      0 ,     1 ,     0 ,    -50 ,   0 ,   0 ,   0 ,   0 };	// gbNo[̉l
int   track_e[]       = {    255 ,     9 ,   255 ,     50 , 256 , 256 , 256 , 256 };	// gbNo[̏l
#endif

#define check_N 1
#if check_N
TCHAR *check_name[]   = { "͈͕\" };	// `FbN{bNX
int   check_default[] = {  0 };	// ftHg
#endif

#define tDEPTH  0
#define tBLUR   1
#define tBUMP   2
#define tCUBIC  3
#define tTOP    4
#define tBTM    5
#define tLEFT   6
#define tRIGHT  7
#define cDISP   0


FILTER_DLL filter = {
	FILTER_FLAG_EX_INFORMATION,
	NULL,NULL,      	// ݒEChẼTCY
	filtername,     	// tB^̖O
	track_N,        	// gbNo[̐
#if track_N
	track_name,     	// gbNo[̖OS
	track_default,  	// gbNo[̏lS
	track_s,track_e,	// gbNo[̐l̉
#else
	NULL,NULL,NULL,NULL,
#endif
	check_N,      	// `FbN{bNX̐
#if check_N
	check_name,   	// `FbN{bNX̖OS
	check_default,	// `FbN{bNX̏lS
#else
	NULL,NULL,
#endif
	func_proc,   	// tB^֐
	NULL,NULL,   	// Jn,IɌĂ΂֐
	func_update,   	// ݒ肪ύXꂽƂɌĂ΂֐
	func_WndProc,	// ݒEBhEvV[W
	NULL,NULL,   	// VXeŎgp
	NULL,NULL,   	// gf[^̈
	filterinfo,  	// tB^
	NULL,			// Z[uJnOɌĂ΂֐
	NULL,			// Z[uIɌĂ΂֐
	NULL,NULL,NULL,	// VXeŎgp
	NULL,			// g̈揉l
};

/*********************************************************************
*	DLL Export
*********************************************************************/
EXTERN_C FILTER_DLL __declspec(dllexport) * __stdcall GetFilterTable( void )
{
	return &filter;
}

//---------------------------------------------------------------------
//		tB^ݒύX֐
//---------------------------------------------------------------------
BOOL func_update( FILTER *fp, int status )
{
	// Cubic
	cubic.SetTable(fp->track[tCUBIC]);
	
	return TRUE;
}

/*====================================================================
*	tB^֐
*===================================================================*/
BOOL func_proc(FILTER *fp,FILTER_PROC_INFO *fpip)
{
#if defined(DEBUG)
	unsigned __int64 *perf, *perfm;
	for(int i=0;i<5;i++)
	{
		perfsum[i] = 0.0;
		perfcount[i] = 0;
	}
	perfm = _perf_start();
#endif
	FILTER_PARAM	filter_param	= {fp, fpip};
	fixedw = (fpip->w+7)&(~7);	// 16Byte Aligned Width

	DefaultPicture defpic(fpip);

	if(fp->track[tTOP] || fp->track[tBTM] || fp->track[tLEFT] || fp->track[tRIGHT]){
		// ͈͎w肳Ă
		
		// O͈͂TCY𒴂Ăꍇ͏Ӗ
		if(fp->track[tTOP]+fp->track[tBTM]>=fpip->h-3 || fp->track[tLEFT]+fp->track[tRIGHT]>=fpip->w-3)
			return FALSE;

		CopyEdge(fp,fpip);	// ͈͊ORs[
		fpip->ycp_edit += fp->track[tLEFT] + fp->track[tTOP] * fpip->max_w;
		fpip->ycp_temp += fp->track[tLEFT] + fp->track[tTOP] * fpip->max_w;
		fpip->w        -= fp->track[tLEFT] + fp->track[tRIGHT];
		fpip->h        -= fp->track[tTOP]  + fp->track[tBTM];
	}

	if(fp->check[cDISP]){	// Kp͈͕\
		fp->exfunc->exec_multi_thread_func(NegaPosi_MT, (void *)fp, (void *)fpip);	// NegativePositive
		defpic.Store(fpip);
		return TRUE;
	}

	int i;
	_MM_ALIGN16 short *ybuf = (short*)_aligned_malloc(fixedw*fpip->h*sizeof(short), 16);
	_MM_ALIGN16 short *bump = (short*)_aligned_malloc(fixedw*fpip->h*sizeof(short), 16);
	short *bum  = bump;

#if defined(DEBUG)
	perf = _perf_start();
#endif
	// Yo
	fp->exfunc->exec_multi_thread_func(PickY_MT, (void *)&filter_param, (void *)ybuf);
#if defined(DEBUG)
	_perf_end(perf, 0);
#endif

#if defined(DEBUG)
	perf = _perf_start();
#endif
	// ֊so
	BUMP_PARAM	bump_param	= {bum, ybuf};
	fp->exfunc->exec_multi_thread_func(Bump_MT, (void *)&filter_param, (void *)&bump_param);
#if defined(DEBUG)
	_perf_end(perf, 1);
#endif

	//ڂobt@m
	int   rowsize = (fpip->w+15)&~15;
	_MM_ALIGN16 short *buf = (short*)_aligned_malloc(fixedw*fpip->h*sizeof(short), 16);
	BLUR_PARAM	blur_param	= {bum, buf};
	
#if defined(DEBUG)
	perf = _perf_start();
#endif
	for(i=fp->track[tBLUR];i;--i) {	// wڂ
		//ڂ
		fp->exfunc->exec_multi_thread_func(BlurRow_MT, (void *)fpip, (void *)&blur_param);
		//cڂ
		fp->exfunc->exec_multi_thread_func(BlurCol_MT, (void *)fpip, (void *)&blur_param);
	}
#if defined(DEBUG)
	_perf_end(perf, 2);
#endif
	
	//ڂobt@
	_aligned_free(buf);

#if defined(DEBUG)
	perf = _perf_start();
#endif
	// WarpSharp
	PIXEL_YC* dst = fpip->ycp_temp;
	const PIXEL_YC* src = fpip->ycp_edit;
	BUMP_PARAM	ws_param	= {bum, ybuf};

	fp->exfunc->exec_multi_thread_func(WarpSharp_MT, (void *)&filter_param, (void *)&ws_param);
	
#if defined(DEBUG)
	_perf_end(perf, 3);
#endif
	defpic.ExchangeStore(fpip);
/* test *
	for(i=0;i<fpip->h;i++){
		for(int j=0;j<fpip->w;j++){
			fpip->ycp_edit[i*fpip->max_w+j].y = bump[i*fpip->w+j];
		}
	}

//*/
#if defined(DEBUG)
	_perf_end(perfm, 4);
	for(int i=0;i<5;i++)
	{
		perfsum[i+5] += perfsum[i];
		perfcount[i+5] ++;
	}
	_perf_result(fpip, fp->exfunc);
#endif
	_aligned_free(bump);
	_aligned_free(ybuf);

	return TRUE;
}

/*--------------------------------------------------------------------
*	Yo	(MT)
*-------------------------------------------------------------------*/
static void PickY(short *dst,const FILTER_PROC_INFO* fpip, int y_start, int y_end)
{
	short *src = (short*)fpip->ycp_edit;

	//XbhƂ̏ʒuɏC
	dst += y_start * fixedw;
	src += y_start * fpip->max_w * 3;
	int proc_h = y_end - y_start +1;
	const int x_simd32  = fixedw&(~31);
	
	for(int i=0;i<proc_h;i++){
		int j = 0;
		for(;j<x_simd32;j+=32){
			__m128i r0, r1, r2, r3;
			r0 = _mm_insert_epi16(r0, *(src   ), 0);
			r1 = _mm_insert_epi16(r1, *(src+24), 0);
			r2 = _mm_insert_epi16(r2, *(src+48), 0);
			r3 = _mm_insert_epi16(r3, *(src+72), 0);
			r0 = _mm_insert_epi16(r0, *(src+ 3), 1);
			r1 = _mm_insert_epi16(r1, *(src+27), 1);
			r2 = _mm_insert_epi16(r2, *(src+51), 1);
			r3 = _mm_insert_epi16(r3, *(src+75), 1);
			r0 = _mm_insert_epi16(r0, *(src+ 6), 2);
			r1 = _mm_insert_epi16(r1, *(src+30), 2);
			r2 = _mm_insert_epi16(r2, *(src+54), 2);
			r3 = _mm_insert_epi16(r3, *(src+78), 2);
			r0 = _mm_insert_epi16(r0, *(src+ 9), 3);
			r1 = _mm_insert_epi16(r1, *(src+33), 3);
			r2 = _mm_insert_epi16(r2, *(src+57), 3);
			r3 = _mm_insert_epi16(r3, *(src+81), 3);
			r0 = _mm_insert_epi16(r0, *(src+12), 4);
			r1 = _mm_insert_epi16(r1, *(src+36), 4);
			r2 = _mm_insert_epi16(r2, *(src+60), 4);
			r3 = _mm_insert_epi16(r3, *(src+84), 4);
			r0 = _mm_insert_epi16(r0, *(src+15), 5);
			r1 = _mm_insert_epi16(r1, *(src+39), 5);
			r2 = _mm_insert_epi16(r2, *(src+63), 5);
			r3 = _mm_insert_epi16(r3, *(src+87), 5);
			r0 = _mm_insert_epi16(r0, *(src+18), 6);
			r1 = _mm_insert_epi16(r1, *(src+42), 6);
			r2 = _mm_insert_epi16(r2, *(src+66), 6);
			r3 = _mm_insert_epi16(r3, *(src+90), 6);
			r0 = _mm_insert_epi16(r0, *(src+21), 7);
			r1 = _mm_insert_epi16(r1, *(src+45), 7);
			r2 = _mm_insert_epi16(r2, *(src+69), 7);
			r3 = _mm_insert_epi16(r3, *(src+93), 7);
			_mm_store_si128((__m128i*)(dst   ), r0);
			_mm_store_si128((__m128i*)(dst+ 8), r1);
			_mm_store_si128((__m128i*)(dst+16), r2);
			_mm_store_si128((__m128i*)(dst+24), r3);
			dst += 32;
			src += 96;
		}
		for(;j<fpip->w;j++){
			*dst = *src;
			dst += 1;
			src += 3;
		}
		dst += fixedw - fpip->w;
		src += (fpip->max_w - fpip->w)*3;
	}
}
//}`Xbh
static void PickY_MT(int thread_id,int thread_num,void *param1,void *param2)
{
	FILTER *fp				= ((FILTER_PARAM *)param1)->fp;
	FILTER_PROC_INFO *fpip	= ((FILTER_PARAM *)param1)->fpip;
	short *dst = (short *)param2;
	
	//摜cɃXbhď͈͌vZ
	int y_start = ( fpip->h * thread_id     ) / thread_num;
	int y_end   = (( fpip->h * (thread_id+1) ) / thread_num) -1;

	PickY(dst, fpip,  y_start, y_end);
}


/*--------------------------------------------------------------------
*	Bump	֊so	(MT)
*-------------------------------------------------------------------*/
static void Bump(short *dst,const short *src, const FILTER_PROC_INFO* fpip,int bump, int y_start, int y_end)
{
	const int x_simd8 = ((fpip->w-9)&(~7))+8;
	const int x_simd16 = ((fpip->w-9)&(~15))+8;
	const __m128i pbump = _mm_set1_epi16(bump);
	//XbhƂ̏ʒuɏC
	dst += y_start * fixedw;
	src += y_start * fixedw;
	int proc_h = y_end - y_start +1;
	
	//ԏ0NA
	if (y_start == 0) {
		memset(dst,0,fpip->w*sizeof(*dst));
		dst += fixedw;
		src += fixedw;
		
		proc_h--;
	}
	if (y_end >= fpip->h -1) {
		proc_h--;
	}

	for(int i=proc_h;i;--i){
		//[0NA
		*dst = 0;

		dst ++;
		src ++;
		int j = 1;
		// To first 16byte alignment
		for(;j<8&&j<fpip->w-1;j++){
			int dx,dy;
			//dx = abs(++-E+E+E)
			dx = abs(src[-1-fixedw] + src[-1] + src[-1+fixedw]
					- src[1-fixedw] - src[1] - src[1+fixedw]);
			//dy = abs(++E---E)
			dy = abs(src[-fixedw-1] + src[-fixedw] + src[-fixedw+1]
					- src[fixedw-1] - src[fixedw] - src[fixedw+1]);

			int level = 3*(dx+dy) + abs(dx-dy);

			*dst = (level>bump) ? bump : level;

			dst += 1;
			src += 1;
		}
		for(;j<x_simd16;j+=16){
			__m128i r0, r1, r2, r3, r4, r5, r6, r7;
			r0 = _mm_lddqu_si128((__m128i*)(src-1-fixedw  ));
			r1 = _mm_lddqu_si128((__m128i*)(src-1         ));
			r2 = _mm_lddqu_si128((__m128i*)(src-1+fixedw  ));
			r3 = _mm_lddqu_si128((__m128i*)(src+1-fixedw  ));
			r4 = _mm_lddqu_si128((__m128i*)(src+1         ));
			r5 = _mm_lddqu_si128((__m128i*)(src+1+fixedw  ));
			r6 = _mm_load_si128( (__m128i*)(src  -fixedw  ));
			r7 = _mm_load_si128( (__m128i*)(src  +fixedw  ));
			r0 = _mm_sub_epi16(r0, r5);
			r1 = _mm_sub_epi16(r1, r4);
			r5 = r0;
			r2 = _mm_sub_epi16(r2, r3);
			r3 = _mm_lddqu_si128((__m128i*)(src-1-fixedw+8));
			r6 = _mm_sub_epi16(r6, r7);
			r7 = _mm_lddqu_si128((__m128i*)(src-1       +8));
			r0 = _mm_add_epi16(r0, r2);
			r5 = _mm_sub_epi16(r5, r2);
			r2 = _mm_lddqu_si128((__m128i*)(src-1+fixedw+8));
			r0 = _mm_add_epi16(r0, r1);
			r1 = _mm_lddqu_si128((__m128i*)(src+1-fixedw+8));
			r5 = _mm_add_epi16(r5, r6);
			r6 = _mm_lddqu_si128((__m128i*)(src+1       +8));
			r0 = _mm_abs_epi16(r0);
			r5 = _mm_abs_epi16(r5);
			r4 = r0;
			r0 = _mm_add_epi16(r0, r5);
			r4 = _mm_sub_epi16(r4, r5);
			r5 = _mm_lddqu_si128((__m128i*)(src+1+fixedw+8));
			r0 = _mm_min_epi16(r0, *(__m128i*)c4095);
			r4 = _mm_abs_epi16(r4);
			r0 = _mm_mullo_epi16(r0, *(__m128i*)c3);
			r3 = _mm_sub_epi16(r3, r5);
			r7 = _mm_sub_epi16(r7, r6);
			r0 = _mm_adds_epi16(r0, r4);
			r4 = _mm_load_si128( (__m128i*)(src  -fixedw+8));
			r0 = _mm_min_epi16(r0, pbump);
			r5 = r3;
			_mm_store_si128((__m128i*)(dst  ), r0);
			r0 = _mm_load_si128( (__m128i*)(src  +fixedw+8));
			r2 = _mm_sub_epi16(r2, r1);
			r4 = _mm_sub_epi16(r4, r0);
			r3 = _mm_add_epi16(r3, r2);
			r5 = _mm_sub_epi16(r5, r2);
			r3 = _mm_add_epi16(r3, r7);
			r5 = _mm_add_epi16(r5, r4);
			r3 = _mm_abs_epi16(r3);
			r5 = _mm_abs_epi16(r5);
			r6 = r3;
			r3 = _mm_add_epi16(r3, r5);
			r6 = _mm_sub_epi16(r6, r5);
			r3 = _mm_min_epi16(r3, *(__m128i*)c4095);
			r6 = _mm_abs_epi16(r6);
			r3 = _mm_mullo_epi16(r3, *(__m128i*)c3);
			r3 = _mm_adds_epi16(r3, r6);
			r3 = _mm_min_epi16(r3, pbump);
			_mm_store_si128((__m128i*)(dst+8), r3);
			dst += 16;
			src += 16;
		}
		for(;j<x_simd8;j+=8){
			/*
				A : -1-fpip->max_w
				B : -1
				C : -1+fpip->max_w
				D :  1-fpip->max_w
				E :  1            
				F :  1+fpip->max_w
				G :   -fpip->max_w
				H :    fpip->max_w
				dx = abs(A + B + C - D - E - F) = (A-F) + (C-D) + (B-E)
				dy = abs(A + G + D - C - H - F) = (A-F) - (C-D) + (G-H)
			*/
			__m128i r0, r1, r2, r3, r4, r5, r6, r7;
			r0 = _mm_lddqu_si128((__m128i*)(src-1-fixedw));	// A
			r1 = _mm_lddqu_si128((__m128i*)(src-1       ));	// B
			r2 = _mm_lddqu_si128((__m128i*)(src-1+fixedw));	// C
			r3 = _mm_lddqu_si128((__m128i*)(src+1-fixedw));	// D
			r4 = _mm_lddqu_si128((__m128i*)(src+1       ));	// E
			r5 = _mm_lddqu_si128((__m128i*)(src+1+fixedw));	// F
			r6 = _mm_load_si128( (__m128i*)(src  -fixedw));	// G
			r7 = _mm_load_si128( (__m128i*)(src  +fixedw));	// H
			r0 = _mm_sub_epi16(r0, r5);	// (A-F)
			r1 = _mm_sub_epi16(r1, r4);	// (B-E)
			r5 = r0;
			r2 = _mm_sub_epi16(r2, r3);	// (C-D)
			r6 = _mm_sub_epi16(r6, r7);	// (G-H)
			r0 = _mm_add_epi16(r0, r2);	// (A-F) + (C-D)
			r5 = _mm_sub_epi16(r5, r2);	// (A-F) - (C-D)
			r0 = _mm_add_epi16(r0, r1);	// (A-F) + (C-D) + (B-E)
			r5 = _mm_add_epi16(r5, r6);	// (A-F) - (C-D) + (G-H)
			r0 = _mm_abs_epi16(r0);	// dx
			r5 = _mm_abs_epi16(r5);	// dy
			r4 = r0;
			r0 = _mm_add_epi16(r0, r5);	// (dx+dy)
			r4 = _mm_sub_epi16(r4, r5);
			// ŒӂȂƃI[o[t[
			r0 = _mm_min_epi16(r0, *(__m128i*)c4095);	// o͂4095𒴂Ȃ̂ŃNbv
			r4 = _mm_abs_epi16(r4);	// abs(dx-dy)
			r0 = _mm_mullo_epi16(r0, *(__m128i*)c3);	// ő4095*3<32737Ȃ̂ŃI[o[t[Ȃ
			r0 = _mm_adds_epi16(r0, r4);				// OaZȂ̂ŃI[o[t[Ȃ
			r0 = _mm_min_epi16(r0, pbump);				// bump𒴂Ȃ
			_mm_store_si128((__m128i*)(dst), r0);
			dst += 8;
			src += 8;
		}
		for(;j<fpip->w-1;j++){
			int dx,dy;
			//dx = abs(++-E+E+E)
			dx = abs(src[-1-fixedw] + src[-1] + src[-1+fixedw]
					- src[1-fixedw] - src[1] - src[1+fixedw]);
			//dy = abs(++E---E)
			dy = abs(src[-fixedw-1] + src[-fixedw] + src[-fixedw+1]
					- src[fixedw-1] - src[fixedw] - src[fixedw+1]);

			int level = 3*(dx+dy) + abs(dx-dy);

			*dst = (level>bump) ? bump : level;

			dst += 1;
			src += 1;
		}
		//E[0NA
		*dst = 0;

		src += (fixedw-fpip->w)+1;
		dst += (fixedw-fpip->w)+1;
	}
	//ԉ0NA
	if (y_end >= fpip->h -1) {
		memset(dst,0,fpip->w*sizeof(*dst));
	}
}
//}`Xbh
static void Bump_MT(int thread_id,int thread_num,void *param1,void *param2)
{
	FILTER *fp				= ((FILTER_PARAM *)param1)->fp;
	FILTER_PROC_INFO *fpip	= ((FILTER_PARAM *)param1)->fpip;
	short *bum = ((BUMP_PARAM *)param2)->bump;
	short *src = ((BUMP_PARAM *)param2)->src_y;
	
	//摜cɃXbhď͈͌vZ
	int y_start = ( fpip->h * thread_id     ) / thread_num;
	int y_end   = (( fpip->h * (thread_id+1) ) / thread_num) -1;

	Bump(bum, src, fpip, fp->track[tBUMP]*16, y_start, y_end);
}


//--------------------------------------------------------------------
//	BlurRow	ڂ
//--------------------------------------------------------------------
static void BlurRow(short *dst, short* src, const FILTER_PROC_INFO* fpip, int y_start, int y_end)
{
	const int rp = fpip->w - 4;
	const int x_simd8  = rp&(~7);
	const int x_simd16 = rp&(~15);
	
	for(int y = y_start; y <= y_end; y++) {
		short *dst_r = dst + y * fixedw;
		short *src_r = src + y * fixedw;

		//[F[11]-4-1 / 5-[6]-4-1
		dst_r[0] = (src_r[0]*11 + src_r[1]*4 + src_r[2]              +8) >>4;
		dst_r[1] = (src_r[0]*5  + src_r[1]*6 + src_r[2]*4 + src_r[3] +8) >>4;
	
		//ʏ폈F1-4-[6]-4-1
		int x = 2;
		//16PSSE
		for(; x < x_simd16; x+=16) {
			__m128i r0, r1, r2, r3, r4, r5;
			r0 = _mm_load_si128((__m128i *)&src_r[x- 2]);
			r4 = _mm_load_si128((__m128i *)&src_r[x+ 6]);
			r1 = r4;
			r2 = r4;
			r3 = r4;
			r5 = r4;
			r1 = _mm_alignr_epi8(r1, r0,  2);
			r2 = _mm_alignr_epi8(r2, r0,  4);
			r3 = _mm_alignr_epi8(r3, r0,  6);
			r4 = _mm_alignr_epi8(r4, r0,  8);
			r0 = _mm_add_epi16(r0, r4);
			r4 = _mm_loadl_epi64((__m128i *)&src_r[x+14]);
			r1 = _mm_add_epi16(r1, r3);
			r3 = r4;
			r2 = _mm_mullo_epi16(r2, *(__m128i*)(c6));
			r1 = _mm_slli_epi16(r1, 2);
			r0 = _mm_add_epi16(r0, *(__m128i*)(c8));
			r1 = _mm_add_epi16(r1, r2);
			r2 = r4;
			r0 = _mm_add_epi16(r0, r1);
			r1 = r4;
			r0 = _mm_srli_epi16(r0, 4);
			r3 = _mm_alignr_epi8(r3, r5,  2);
			r2 = _mm_alignr_epi8(r2, r5,  4);
			r1 = _mm_alignr_epi8(r1, r5,  6);
			_mm_storeu_si128((__m128i *)&dst_r[x  ], r0);
			r4 = _mm_alignr_epi8(r4, r5,  8);
			r5 = _mm_add_epi16(r5, r4);
			r3 = _mm_add_epi16(r3, r1);
			r2 = _mm_mullo_epi16(r2, *(__m128i*)(c6));
			r3 = _mm_slli_epi16(r3, 2);
			r5 = _mm_add_epi16(r5, *(__m128i*)(c8));
			r3 = _mm_add_epi16(r3, r2);
			r5 = _mm_add_epi16(r5, r3);
			r5 = _mm_srli_epi16(r5, 4);
			_mm_storeu_si128((__m128i *)&dst_r[x+8], r5);
		}
		//8PSSE
		for(; x < x_simd8; x+=8) {
			__m128i r0, r1, r2, r3, r4;
			r0 = _mm_load_si128( (__m128i *)&src_r[x- 2]);
			r4 = _mm_loadl_epi64((__m128i *)&src_r[x+ 6]);
			r1 = r4;
			r2 = r4;
			r3 = r4;
			r1 = _mm_alignr_epi8(r1, r0,  2);
			r2 = _mm_alignr_epi8(r2, r0,  4);
			r3 = _mm_alignr_epi8(r3, r0,  6);
			r4 = _mm_alignr_epi8(r4, r0,  8);
			r0 = _mm_add_epi16(r0, r4);
			r1 = _mm_add_epi16(r1, r3);
			r2 = _mm_mullo_epi16(r2, *(__m128i*)(c6));
			r1 = _mm_slli_epi16(r1, 2);
			r0 = _mm_add_epi16(r0, *(__m128i*)(c8));
			r1 = _mm_add_epi16(r1, r2);
			r0 = _mm_add_epi16(r0, r1);
			r0 = _mm_srli_epi16(r0, 4);
			_mm_storeu_si128((__m128i *)&dst_r[x  ], r0);
		}
		//8PSSE]
		for(; x < rp; x++) {
			dst_r[x] = (src_r[x-2] + src_r[x-1]*4 + src_r[x]*6 + src_r[x+1]*4 + src_r[x+2] +8) >>4;
		}
	
		//E[F1-4-[6]-5 / 1-4-[11]
		dst_r[rp]   = (src_r[rp-2] + src_r[rp-1]*4 + src_r[rp]*6 + src_r[rp+1]*5  +8) >>4;
		dst_r[rp+1] = (              src_r[rp-1]   + src_r[rp]*4 + src_r[rp+1]*11 +8) >>4;
	}
}
//}`Xbh
static void BlurRow_MT(int thread_id,int thread_num,void *param1,void *param2)
{
	FILTER_PROC_INFO *fpip	= (FILTER_PROC_INFO *)param1;
	short *buf = ((BLUR_PARAM *)param2)->buf;
	short *dst = ((BLUR_PARAM *)param2)->dst;
	
	//摜cɃXbhď͈͌vZ
	int y_start = ( fpip->h * thread_id     ) / thread_num;
	int y_end   = (( fpip->h * (thread_id+1) ) / thread_num) -1;
	
	BlurRow(buf, dst, fpip, y_start, y_end);
}

//--------------------------------------------------------------------
//	BlurCol	cڂ
//--------------------------------------------------------------------
static void BlurCol(short *dst, short* src, const FILTER_PROC_INFO* fpip, int x_start, int x_end)
{
	//esړ
	int y1 = fixedw;
	int y2 = y1 + fixedw;
	int y3 = y2 + fixedw;
	int y4 = y3 + fixedw;
	
	int x;
	int x8 = (x_start+7)&(~7);
	
	const int x_simd8 = ((x_end - x8)&(~7)) + x8;
	const int x_simd16 = ((x_end - x8)&(~15)) + x8;
	
	//[F[11]-4-1 / 5-[6]-4-1
	for(x=x_start; x<x8; x++) {
		dst[x]    = (src[x]*11 + src[y1+x]*4 + src[y2+x]               +8) >>4;
		dst[y1+x] = (src[x]*5  + src[y1+x]*6 + src[y2+x]*4 + src[y3+x] +8) >>4;
	}
	for(; x<x_simd8; x+=8) {
		__m128i r0, r1, r2, r3, r4, r5, r6;
		r0 = _mm_load_si128((__m128i *)&src[x   ]);
		r1 = _mm_load_si128((__m128i *)&src[x+y1]);
		r2 = _mm_load_si128((__m128i *)&src[x+y2]);
		r3 = _mm_load_si128((__m128i *)&src[x+y3]);
		r4 = r0;
		r5 = r1;
		r6 = r2;
		r0 = _mm_mullo_epi16(r0, *(__m128i*)(c11));
		r1 = _mm_slli_epi16(r1, 2);
		r2 = _mm_add_epi16(r2, *(__m128i*)(c8));
		r4 = _mm_mullo_epi16(r4, *(__m128i*)(c5));
		r5 = _mm_mullo_epi16(r5, *(__m128i*)(c6));
		r6 = _mm_slli_epi16(r6, 2);
		r4 = _mm_add_epi16(r4, *(__m128i*)(c8));
		r0 = _mm_add_epi16(r0, r1);
		r5 = _mm_add_epi16(r5, r6);
		r0 = _mm_add_epi16(r0, r2);
		r5 = _mm_add_epi16(r5, r4);
		r0 = _mm_srli_epi16(r0, 4);
		r5 = _mm_srli_epi16(r5, 4);
		_mm_store_si128((__m128i *)&dst[x   ], r0);
		_mm_store_si128((__m128i *)&dst[x+y1], r5);
	}
	for(; x<=x_end; x++) {
		dst[x]    = (src[x]*11 + src[y1+x]*4 + src[y2+x]               +8) >>4;
		dst[y1+x] = (src[x]*5  + src[y1+x]*6 + src[y2+x]*4 + src[y3+x] +8) >>4;
	}
	dst += y2;

	//ʏ폈F1-4-[6]-4-1
	for(int y=2; y<fpip->h -2; y++) {
		for(x=x_start; x<x8; x++) {
			dst[x] = (src[x] + src[y1+x]*4 + src[y2+x]*6 + src[y3+x]*4 + src[y4+x] +8) >>4;
		}
		//16PSSE
		for(; x < x_simd16; x+=16) {
			__m128i r0, r1, r2, r3, r4, r5;
			r0 = _mm_load_si128((__m128i *)&src[x     ]);
			r1 = _mm_load_si128((__m128i *)&src[x+y1  ]);
			r2 = _mm_load_si128((__m128i *)&src[x+y2  ]);
			r3 = _mm_load_si128((__m128i *)&src[x+y3  ]);
			r4 = _mm_load_si128((__m128i *)&src[x+y4  ]);
			r5 = _mm_load_si128((__m128i *)&src[x   +8]);
			r0 = _mm_add_epi16(r0, r4);
			r4 = _mm_load_si128((__m128i *)&src[x+y1+8]);
			r1 = _mm_add_epi16(r1, r3);
			r3 = _mm_load_si128((__m128i *)&src[x+y2+8]);
			r2 = _mm_mullo_epi16(r2, *(__m128i*)(c6));
			r1 = _mm_slli_epi16(r1, 2);
			r0 = _mm_add_epi16(r0, *(__m128i*)(c8));
			r1 = _mm_add_epi16(r1, r2);
			r2 = _mm_load_si128((__m128i *)&src[x+y3+8]);
			r0 = _mm_add_epi16(r0, r1);
			r1 = _mm_load_si128((__m128i *)&src[x+y4+8]);
			r0 = _mm_srli_epi16(r0, 4);
			r5 = _mm_add_epi16(r5, r1);
			_mm_store_si128((__m128i *)&dst[x  ], r0);
			r4 = _mm_add_epi16(r4, r2);
			r3 = _mm_mullo_epi16(r3, *(__m128i*)(c6));
			r4 = _mm_slli_epi16(r4, 2);
			r5 = _mm_add_epi16(r5, *(__m128i*)(c8));
			r4 = _mm_add_epi16(r4, r3);
			r5 = _mm_add_epi16(r5, r4);
			r5 = _mm_srli_epi16(r5, 4);
			_mm_store_si128((__m128i *)&dst[x+8], r5);
		}
		//8PSSE
		for(; x<x_simd8; x+=8) {
			__m128i r0, r1, r2, r3, r4;
			r0 = _mm_load_si128((__m128i *)&src[x   ]);
			r1 = _mm_load_si128((__m128i *)&src[x+y1]);
			r2 = _mm_load_si128((__m128i *)&src[x+y2]);
			r3 = _mm_load_si128((__m128i *)&src[x+y3]);
			r4 = _mm_load_si128((__m128i *)&src[x+y4]);
			r0 = _mm_add_epi16(r0, r4);
			r1 = _mm_add_epi16(r1, r3);
			r2 = _mm_mullo_epi16(r2, *(__m128i*)(c6));
			r1 = _mm_slli_epi16(r1, 2);
			r0 = _mm_add_epi16(r0, *(__m128i*)(c8));
			r1 = _mm_add_epi16(r1, r2);
			r0 = _mm_add_epi16(r0, r1);
			r0 = _mm_srli_epi16(r0, 4);
			_mm_store_si128((__m128i *)&dst[x  ], r0);
		}
		for(; x<=x_end; x++) {
			dst[x] = (src[x] + src[y1+x]*4 + src[y2+x]*6 + src[y3+x]*4 + src[y4+x] +8) >>4;
		}
		dst += y1;
		src += y1;
	}

	//[F1-4-[6]-5 / 1-4-[11]
	for(x=x_start; x<x8; x++) {
		dst[x]    = (src[x] + src[y1+x]*4 + src[y2+x]*6 + src[y3+x]*5  +8) >>4;
		dst[y1+x] = (         src[y1+x]   + src[y2+x]*4 + src[y3+x]*11 +8) >>4;
	}
	for(; x<x_simd8; x+=8) {
		__m128i r0, r1, r2, r3, r4, r5, r6;
		r0 = _mm_load_si128((__m128i *)&src[x   ]);
		r1 = _mm_load_si128((__m128i *)&src[x+y1]);
		r2 = _mm_load_si128((__m128i *)&src[x+y2]);
		r3 = _mm_load_si128((__m128i *)&src[x+y3]);
		r4 = r1;
		r5 = r2;
		r6 = r3;
		r0 = _mm_add_epi16(r0, *(__m128i*)(c8));
		r1 = _mm_slli_epi16(r1, 2);
		r2 = _mm_mullo_epi16(r2, *(__m128i*)(c6));
		r3 = _mm_mullo_epi16(r3, *(__m128i*)(c5));
		r4 = _mm_add_epi16(r4, *(__m128i*)(c8));
		r5 = _mm_slli_epi16(r5, 2);
		r6 = _mm_mullo_epi16(r6, *(__m128i*)(c11));
		r0 = _mm_add_epi16(r0, r1);
		r4 = _mm_add_epi16(r4, r5);
		r0 = _mm_add_epi16(r0, r2);
		r4 = _mm_add_epi16(r5, r6);
		r0 = _mm_srli_epi16(r0, 4);
		r4 = _mm_srli_epi16(r4, 4);
		_mm_store_si128((__m128i *)&dst[x   ], r0);
		_mm_store_si128((__m128i *)&dst[x+y1], r4);
	}
	for(; x<=x_end; x++) {
		dst[x]    = (src[x] + src[y1+x]*4 + src[y2+x]*6 + src[y3+x]*5  +8) >>4;
		dst[y1+x] = (         src[y1+x]   + src[y2+x]*4 + src[y3+x]*11 +8) >>4;
	}
}
//}`Xbh
static void BlurCol_MT(int thread_id,int thread_num,void *param1,void *param2)
{
	FILTER_PROC_INFO *fpip	= (FILTER_PROC_INFO *)param1;
	short *buf = ((BLUR_PARAM *)param2)->buf;
	short *dst = ((BLUR_PARAM *)param2)->dst;
	
	//摜cɃXbhď͈͌vZ
	int x_start = ( fpip->w * thread_id     ) / thread_num;
	int x_end   = (( fpip->w * (thread_id+1) ) / thread_num) -1;
	
	BlurCol(dst, buf, fpip, x_start, x_end);
}

//--------------------------------------------------------------------
//	WarpSharp
//--------------------------------------------------------------------
static void WarpSharp(short *bum, short *ysrc, const FILTER *fp, const FILTER_PROC_INFO* fpip, int y_start, int y_end)
{
	int depth = fp->track[tDEPTH];
	PIXEL_YC* dst = fpip->ycp_temp;
	const PIXEL_YC* src = fpip->ycp_edit;

	//XbhƂ̏ʒuɏC
	dst += y_start * fpip->max_w;
	src += y_start * fpip->max_w;
	ysrc += y_start * fixedw;
	bum += y_start * fixedw;
	int proc_h = y_end - y_start +1;
	
	if (y_start == 0) {
		//[͂̂܂܃Rs[
		memcpy(dst,src,fpip->w*sizeof(*dst));
		dst += fpip->max_w;
		src += fpip->max_w;
		ysrc += fixedw;
		bum += fixedw;
		
		proc_h--;
	}
	if (y_end >= fpip->h -1) {
		proc_h--;
	}
	
	int lo_dispy = (-y_start) * 256;
	int hi_dispy = (fpip->h - 3 - y_start) *256 -1;

	for(int h=proc_h; h; --h){
		*dst = *src;
		bum+=1; ++dst; ++src;
		++ysrc;

		int lo_dispx = 0;
		int hi_dispx = (fpip->w - 3) *256 -1;

		for(int w=fpip->w-2; w; --w){
			int dispx = bum[-1] - bum[1];
			int dispy = bum[-fixedw] - bum[fixedw];

			dispx = (dispx * depth +128) >>8;// (dispx * depth +8) >>4;
			dispy = (dispy * depth +128) >>8;

			if(dispx < lo_dispx)      dispx = lo_dispx;
			else if(dispx > hi_dispx) dispx = hi_dispx;

			if(dispy < lo_dispy)      dispy = lo_dispy;
			else if(dispy > hi_dispy) dispy = hi_dispy;
			
			const short* src2 = ysrc + ((dispx>>8)-1) + ((dispy>>8)-1)*fixedw;
			
			const int *qh = (int*)cubic + (dispx & 255) * 4;
			const int *qv = (int*)cubic + (dispy & 255) * 4;

			dst->y = InterpolateCubic(src2,fixedw,qh,qv);
			dst->cb = src->cb;
			dst->cr = src->cr;

			++dst; ++src; ++bum;
			++ysrc;
			lo_dispx -= 256;
			hi_dispx -= 256;
		}
		*dst = *src;

		dst += fpip->max_w - fpip->w +1;
		src += fpip->max_w - fpip->w +1;
		ysrc += fixedw - fpip->w +1;
		bum += fixedw - fpip->w +1;

		lo_dispy -= 256;
		hi_dispy -= 256;
	}
	//[̂܂܃Rs[
	if (y_end >= fpip->h -1) {
		memcpy(dst,src,fpip->w*sizeof(*dst));
	}
}
//}`Xbh
static void WarpSharp_MT(int thread_id,int thread_num,void *param1,void *param2)
{
	FILTER *fp				= ((FILTER_PARAM *)param1)->fp;
	FILTER_PROC_INFO *fpip	= ((FILTER_PARAM *)param1)->fpip;
	short *bum = ((BUMP_PARAM *)param2)->bump;
	short *src = ((BUMP_PARAM *)param2)->src_y;
	
	//摜cɃXbhď͈͌vZ
	int y_start = ( fpip->h * thread_id     ) / thread_num;
	int y_end   = (( fpip->h * (thread_id+1) ) / thread_num) -1;
	
	WarpSharp(bum, src, fp, fpip, y_start, y_end);
}


/*--------------------------------------------------------------------
*	InterpolateCubic
*-------------------------------------------------------------------*/
inline int InterpolateCubic(const short* src,int pitch,const int *qh,const int *qv)
{
	const short* p0 = src;
	const short* p1 = p0 + pitch;
	const short* p2 = p1 + pitch;
	const short* p3 = p2 + pitch;
	int luma;
	
	luma  = ((p0[0]*qh[0] + p0[1]*qh[1] + p0[2]*qh[2] + p0[3]*qh[3] + 1024) >>11) * qv[0];
	luma += ((p1[0]*qh[0] + p1[1]*qh[1] + p1[2]*qh[2] + p1[3]*qh[3] + 1024) >>11) * qv[1];
	luma += ((p2[0]*qh[0] + p2[1]*qh[1] + p2[2]*qh[2] + p2[3]*qh[3] + 1024) >>11) * qv[2];
	luma += ((p3[0]*qh[0] + p3[1]*qh[1] + p3[2]*qh[2] + p3[3]*qh[3] + 1024) >>11) * qv[3];
	
	luma = (luma + (1<<16)) >> 17;
	if(luma<AviUtlY(0)) luma = AviUtlY(0);
	else if(luma>AviUtlY(255)) luma = AviUtlY(255);

	return luma;
}

/*--------------------------------------------------------------------
*	NegaPosi	lK|W	(MT)
*-------------------------------------------------------------------*/
static BOOL NegaPosi(FILTER *fp,FILTER_PROC_INFO *fpip, int y_start, int y_end)
{
	PIXEL_YC* ptr1 = fpip->ycp_edit + y_start * fpip->max_w;

	for(int i=y_end - y_start; i; --i){
		PIXEL_YC* ptr2 = ptr1;
		for(int j=fpip->w; j; --j){
			ptr2->y  = 4096 - ptr2->y;
			ptr2->cb = -ptr2->cb;
			ptr2->cr = -ptr2->cr;
			++ptr2;
		}
		ptr1 += fpip->max_w;
	}

	return TRUE;
}
//}`Xbh
static void NegaPosi_MT(int thread_id,int thread_num,void *param1,void *param2)
{
	FILTER *fp				= (FILTER *)param1;
	FILTER_PROC_INFO *fpip	= (FILTER_PROC_INFO *)param2;

	//摜cɃXbhď͈͌vZ
	int y_start = ( fpip->h * thread_id     ) / thread_num;
	int y_end   = ( fpip->h * (thread_id+1) ) / thread_num;
	
	NegaPosi(fp, fpip, y_start, y_end);
}

/*--------------------------------------------------------------------
*	CopyEdge	͈͂̊ORs[
*-------------------------------------------------------------------*/
static void CopyEdge(FILTER *fp,FILTER_PROC_INFO *fpip)
{
	PIXEL_YC* src = fpip->ycp_edit;
	PIXEL_YC* dst = fpip->ycp_temp;
	int i;

	int rowsize = fpip->w*sizeof(PIXEL_YC);

	//㏜O͈͂CRs[
	for(i=fp->track[tTOP];i;--i){
		memcpy(dst,src,rowsize);
		src += fpip->max_w;
		dst += fpip->max_w;
	}
	int rightpitch = fpip->w - fp->track[tRIGHT];
	int right = fp->track[tRIGHT]*sizeof(PIXEL_YC);
	int left  = fp->track[tLEFT]*sizeof(PIXEL_YC);
	//Rs[s=O͈-㏜O͈
	for(i=fpip->h-fp->track[tTOP]-fp->track[tBTM];i;--i){
		PIXEL_YC* src2 = src;
		PIXEL_YC* dst2 = dst;
		//O͈͂Rs[
		memcpy(dst2,src2,left);
		src2 += rightpitch;
		dst2 += rightpitch;
		//EO͈͂Rs[
		memcpy(dst2,src2,right);
		src += fpip->max_w;
		dst += fpip->max_w;
	}
	//O͈͂Rs[
	for(i=fp->track[tBTM];i;--i){
		memcpy(dst,src,rowsize);
		src += fpip->max_w;
		dst += fpip->max_w;
	}

	return;
}

/*====================================================================
*	ݒEBhEvV[W
*===================================================================*/
BOOL func_WndProc( HWND hwnd, UINT message, WPARAM wparam, LPARAM lparam, void *editp, FILTER *fp )
{
	switch(message){
		case WM_KEYUP:	// CEBhE֑
		case WM_KEYDOWN:
//		case WM_MOUSEWHEEL:
			SendMessage(GetWindow(hwnd, GW_OWNER), message, wparam, lparam);
			break;
	}

	return FALSE;
}

